//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3CA20014.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3CA20014.cm

//## begin module%3EEB3CA20014.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3CA20014.cp

//## Module: AbstractConcepts%3EEB3CA20014; Package body
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Abstract Concepts\AbstractConcepts.cpp

//## begin module%3EEB3CA20014.additionalIncludes preserve=no
//## end module%3EEB3CA20014.additionalIncludes

//## begin module%3EEB3CA20014.includes preserve=yes
#include <string.h>
//## end module%3EEB3CA20014.includes

// AbstractConcepts
#include "AbstractConcepts.h"
// Model
#include "Model.h"
// RndGen
#include "RndGen.h"
// Event
#include "Event.h"
// Visitor
#include "Visitor.h"


//## begin module%3EEB3CA20014.declarations preserve=no
//## end module%3EEB3CA20014.declarations

//## begin module%3EEB3CA20014.additionalDeclarations preserve=yes
//## end module%3EEB3CA20014.additionalDeclarations


// Class ModelElement 

//## begin ModelElement::idCounter%3EEB0E850294.attr preserve=no  private: static MEID {UA} 0
MEID ModelElement::idCounter = 0;
//## end ModelElement::idCounter%3EEB0E850294.attr





ModelElement::ModelElement ()
  //## begin ModelElement::ModelElement%3EEB246502BC.hasinit preserve=no
      : id(++idCounter)
  //## end ModelElement::ModelElement%3EEB246502BC.hasinit
  //## begin ModelElement::ModelElement%3EEB246502BC.initialization preserve=yes
  , name(0), descr(0)
  //## end ModelElement::ModelElement%3EEB246502BC.initialization
{
  //## begin ModelElement::ModelElement%3EEB246502BC.body preserve=yes
	Model::Instance()->add(this);
  //## end ModelElement::ModelElement%3EEB246502BC.body
}


ModelElement::~ModelElement ()
{
  //## begin ModelElement::~ModelElement%3EEB247C00DC.body preserve=yes
	Model::Instance()->remove(this);
	delete name;
	delete descr;
  //## end ModelElement::~ModelElement%3EEB247C00DC.body
}



//## Other Operations (implementation)
void ModelElement::setName (String newVal)
{
  //## begin ModelElement::setName%3EED84290244.body preserve=yes
	delete name;
	name = new char[strlen(newVal)+1];
	if (name) strcpy(name,newVal);
  //## end ModelElement::setName%3EED84290244.body
}

void ModelElement::setDescr (String newVal)
{
  //## begin ModelElement::setDescr%3EED844800E7.body preserve=yes
	delete descr;
	descr = new char[strlen(newVal)+1];
	if (descr) strcpy(descr,newVal);
  //## end ModelElement::setDescr%3EED844800E7.body
}

// Additional Declarations
  //## begin ModelElement%3EE081050190.declarations preserve=yes
  //## end ModelElement%3EE081050190.declarations

// Class FlowElement 






// Additional Declarations
  //## begin FlowElement%3EE082C00096.declarations preserve=yes
  //## end FlowElement%3EE082C00096.declarations

// Class ControlElement 

// Additional Declarations
  //## begin ControlElement%3EE083CC0316.declarations preserve=yes
  //## end ControlElement%3EE083CC0316.declarations

// Class RandomTimedFlowElement 


RandomTimedFlowElement::~RandomTimedFlowElement ()
{
  //## begin RandomTimedFlowElement::~RandomTimedFlowElement%3EEB2598037A.body preserve=yes
	delete rndGen;
  //## end RandomTimedFlowElement::~RandomTimedFlowElement%3EEB2598037A.body
}



//## Other Operations (implementation)
void RandomTimedFlowElement::raiseEvent (ID id)
{
  //## begin RandomTimedFlowElement::raiseEvent%3EE0A6BB00D2.body preserve=yes
	Time tm = 0;
	if (rndGen) tm = rndGen->getRandom();
	else return;
	Event::create(this,tm,id);
  //## end RandomTimedFlowElement::raiseEvent%3EE0A6BB00D2.body
}

// Additional Declarations
  //## begin RandomTimedFlowElement%3EE08BB1030C.declarations preserve=yes
  //## end RandomTimedFlowElement%3EE08BB1030C.declarations

// Class Model 



//## Other Operations (implementation)
Model* Model::Instance ()
{
  //## begin Model::Instance%3EEB23E303C0.body preserve=yes
	static Model instance;
	return &instance;
  //## end Model::Instance%3EEB23E303C0.body
}

void Model::accept (Visitor* vis)
{
  //## begin Model::accept%3EEB209D03C0.body preserve=yes
	if (vis) vis->visitModel(this);
  //## end Model::accept%3EEB209D03C0.body
}

void Model::clear ()
{
  //## begin Model::clear%3EEB270603CA.body preserve=yes
	while (!elements.isEmpty()) {
		ModelElement* me = elements.itemAt(0);
		delete me;
		elements.remove(0);
	}
  //## end Model::clear%3EEB270603CA.body
}

// Additional Declarations
  //## begin Model%3EEB204903D4.declarations preserve=yes
  //## end Model%3EEB204903D4.declarations

//## begin module%3EEB3CA20014.epilog preserve=yes
//## end module%3EEB3CA20014.epilog
