//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3E31006E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3E31006E.cm

//## begin module%3EEB3E31006E.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3E31006E.cp

//## Module: Interfaces%3EEB3E31006E; Package specification
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Abstract Concepts\Interfaces.h

#ifndef Interfaces_h
#define Interfaces_h 1

//## begin module%3EEB3E31006E.additionalIncludes preserve=no
//## end module%3EEB3E31006E.additionalIncludes

//## begin module%3EEB3E31006E.includes preserve=yes
#include "Types.h"
//## end module%3EEB3E31006E.includes

//## begin module%3EEB3E31006E.declarations preserve=no
//## end module%3EEB3E31006E.declarations

//## begin module%3EEB3E31006E.additionalDeclarations preserve=yes
//## end module%3EEB3E31006E.additionalDeclarations


//## begin IFlowSource%3EE0867C0014.preface preserve=yes
//## end IFlowSource%3EE0867C0014.preface

//## Class: IFlowSource%3EE0867C0014
//	Interface of Flow Elements representing flow sources
//	that can be switched on and off.
//## Category: Traffic Modeling and Simulation::Concepts::Abstract Concepts%3EE0C06900BE
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class IFlowSource 
{
  //## begin IFlowSource%3EE0867C0014.initialDeclarations preserve=yes
  //## end IFlowSource%3EE0867C0014.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: switchOn%3EE086A000DC
      //	Switch the source on - the source can generate or
      //	transport the flow.
      virtual void switchOn () = 0;

      //## Operation: switchOff%3EE086B7029E
      //	Switch the source off - the source does not generate or
      //	transport the flow any more.
      virtual void switchOff () = 0;

      //## Operation: isOn%3EE0A5D50316
      //	Is the source switched on?
      virtual bool isOn () = 0;

    // Additional Public Declarations
      //## begin IFlowSource%3EE0867C0014.public preserve=yes
      //## end IFlowSource%3EE0867C0014.public

  protected:
    // Additional Protected Declarations
      //## begin IFlowSource%3EE0867C0014.protected preserve=yes
      //## end IFlowSource%3EE0867C0014.protected

  private:
    // Additional Private Declarations
      //## begin IFlowSource%3EE0867C0014.private preserve=yes
      //## end IFlowSource%3EE0867C0014.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin IFlowSource%3EE0867C0014.implementation preserve=yes
      //## end IFlowSource%3EE0867C0014.implementation

};

//## begin IFlowSource%3EE0867C0014.postscript preserve=yes
//## end IFlowSource%3EE0867C0014.postscript

//## begin ITimedElement%3EE08A920082.preface preserve=yes
//## end ITimedElement%3EE08A920082.preface

//## Class: ITimedElement%3EE08A920082
//	Interface of a Model Element that has a time delay of
//	some service, for which it should accept a
//	time-scheduled Event from the simulation engine.
//## Category: Traffic Modeling and Simulation::Concepts::Abstract Concepts%3EE0C06900BE
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class ITimedElement 
{
  //## begin ITimedElement%3EE08A920082.initialDeclarations preserve=yes
  //## end ITimedElement%3EE08A920082.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: notify%3EE08AD700AA
      //	Notifies the receiver of the Event that the requested
      //	time delay has elapsed, or the time-scheduled Event has
      //	occurred.
      virtual void notify (ID id	// Auxiliary identification of the Event.
      ) = 0;

    // Additional Public Declarations
      //## begin ITimedElement%3EE08A920082.public preserve=yes
      //## end ITimedElement%3EE08A920082.public

  protected:
    // Additional Protected Declarations
      //## begin ITimedElement%3EE08A920082.protected preserve=yes
      //## end ITimedElement%3EE08A920082.protected

  private:
    // Additional Private Declarations
      //## begin ITimedElement%3EE08A920082.private preserve=yes
      //## end ITimedElement%3EE08A920082.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin ITimedElement%3EE08A920082.implementation preserve=yes
      //## end ITimedElement%3EE08A920082.implementation

};

//## begin ITimedElement%3EE08A920082.postscript preserve=yes
//## end ITimedElement%3EE08A920082.postscript

// Class IFlowSource 

// Class ITimedElement 

//## begin module%3EEB3E31006E.epilog preserve=yes
//## end module%3EEB3E31006E.epilog


#endif
