//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3C2C01E0.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3C2C01E0.cm

//## begin module%3EEB3C2C01E0.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3C2C01E0.cp

//## Module: Model%3EEB3C2C01E0; Package specification
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Abstract Concepts\Model.h

#ifndef Model_h
#define Model_h 1

//## begin module%3EEB3C2C01E0.additionalIncludes preserve=no
//## end module%3EEB3C2C01E0.additionalIncludes

//## begin module%3EEB3C2C01E0.includes preserve=yes
#include "Types.h"
//## end module%3EEB3C2C01E0.includes

//## begin module%3EEB3C2C01E0.declarations preserve=no
//## end module%3EEB3C2C01E0.declarations

//## begin module%3EEB3C2C01E0.additionalDeclarations preserve=yes
class Visitor;
class ModelElement;
//## end module%3EEB3C2C01E0.additionalDeclarations


//## begin Model%3EEB204903D4.preface preserve=yes
//## end Model%3EEB204903D4.preface

//## Class: Model%3EEB204903D4
//	The entire model, a collection of Model Elements.
//	Singleton. Singleton DP.
//## Category: Traffic Modeling and Simulation::Concepts::Abstract Concepts%3EE0C06900BE
//## Subsystem: Concepts::Abstract Concepts%3EEC42560000
//## Persistence: Transient
//## Cardinality/Multiplicity: 1..1

class Model 
{
  //## begin Model%3EEB204903D4.initialDeclarations preserve=yes
  //## end Model%3EEB204903D4.initialDeclarations

  public:
    //## Destructor (specified)
      //## Operation: ~Model%3EEB24C90302
      //	Destructor. Destroys its Model Elements.
      virtual ~Model ();


    //## Other Operations (specified)
      //## Operation: Instance%3EEB23E303C0
      //	Returns the singleton instance of this class. Static.
      //	Singleton DP.
      static Model* Instance ();

      //## Operation: accept%3EEB209D03C0
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

      //## Operation: add%3EEB242F01AE
      //	Adds a Model Element to the Model.
      virtual void add (ModelElement* me);

      //## Operation: remove%3EEB244A00E6
      //	Removes a Model Element from the Model.
      virtual void remove (ModelElement* me);

      //## Operation: getElements%3EEB250F01D6
      //	Returns the owned Model Elements.
      virtual CollectionME* getElements ();

      //## Operation: clear%3EEB270603CA
      //	Clears the Model. Destroys all its Model Elements.
      virtual void clear ();

    // Additional Public Declarations
      //## begin Model%3EEB204903D4.public preserve=yes
      //## end Model%3EEB204903D4.public

  protected:
    //## Constructors (specified)
      //## Operation: Model%3EEB23FC0082
      //	Constructor. Singleton DP.
      Model ();

    // Additional Protected Declarations
      //## begin Model%3EEB204903D4.protected preserve=yes
      //## end Model%3EEB204903D4.protected

  private:
    // Data Members for Associations

      //## Association: Traffic Modeling and Simulation::Concepts::Abstract Concepts::<unnamed>%3EEB2534017C
      //## Role: Model::elements%3EEB25340334
      //## begin Model::elements%3EEB25340334.role preserve=no  private: ModelElement {1 -> *VFHgAN}
      CollectionME elements;
      //## end Model::elements%3EEB25340334.role

    // Additional Private Declarations
      //## begin Model%3EEB204903D4.private preserve=yes
      //## end Model%3EEB204903D4.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin Model%3EEB204903D4.implementation preserve=yes
      //## end Model%3EEB204903D4.implementation

};

//## begin Model%3EEB204903D4.postscript preserve=yes
//## end Model%3EEB204903D4.postscript

// Class Model 

inline Model::Model ()
  //## begin Model::Model%3EEB23FC0082.hasinit preserve=no
  //## end Model::Model%3EEB23FC0082.hasinit
  //## begin Model::Model%3EEB23FC0082.initialization preserve=yes
  //## end Model::Model%3EEB23FC0082.initialization
{
  //## begin Model::Model%3EEB23FC0082.body preserve=yes
  //## end Model::Model%3EEB23FC0082.body
}


inline Model::~Model ()
{
  //## begin Model::~Model%3EEB24C90302.body preserve=yes
	clear();
  //## end Model::~Model%3EEB24C90302.body
}



//## Other Operations (inline)
inline void Model::add (ModelElement* me)
{
  //## begin Model::add%3EEB242F01AE.body preserve=yes
	if (me) elements.add(me);
  //## end Model::add%3EEB242F01AE.body
}

inline void Model::remove (ModelElement* me)
{
  //## begin Model::remove%3EEB244A00E6.body preserve=yes
	if (me) elements.remove(me);
  //## end Model::remove%3EEB244A00E6.body
}

inline CollectionME* Model::getElements ()
{
  //## begin Model::getElements%3EEB250F01D6.body preserve=yes
	return &elements;
  //## end Model::getElements%3EEB250F01D6.body
}

//## begin module%3EEB3C2C01E0.epilog preserve=yes
//## end module%3EEB3C2C01E0.epilog


#endif
