//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB401A0302.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB401A0302.cm

//## begin module%3EEB401A0302.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB401A0302.cp

//## Module: CrossSem%3EEB401A0302; Package specification
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\CrossSem.h

#ifndef CrossSem_h
#define CrossSem_h 1

//## begin module%3EEB401A0302.additionalIncludes preserve=no
//## end module%3EEB401A0302.additionalIncludes

//## begin module%3EEB401A0302.includes preserve=yes
#include "AbstractConcepts.h"
//## end module%3EEB401A0302.includes

//## begin module%3EEB401A0302.declarations preserve=no
//## end module%3EEB401A0302.declarations

//## begin module%3EEB401A0302.additionalDeclarations preserve=yes
enum CrossDir {horizontal, vertical};
//## end module%3EEB401A0302.additionalDeclarations


//## begin CrossSemaphore%3EE0C298014A.preface preserve=yes
//## end CrossSemaphore%3EE0C298014A.preface

//## Class: CrossSemaphore%3EE0C298014A
//	A simple semaphore for a 2-way crossroad. Switches two
//	directions alternatively.
//## Category: Traffic Modeling and Simulation::Concepts::Modeling Concepts%3EE0C1CA01A4
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class CrossSemaphore : public ControlElement, //## Inherits: <unnamed>%3EE0C3B503AC
                       	public ITimedElement  //## Inherits: <unnamed>%3EEDDF0601A4
{
  //## begin CrossSemaphore%3EE0C298014A.initialDeclarations preserve=yes
  //## end CrossSemaphore%3EE0C298014A.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: CrossSemaphore%3EE0C2C1008C
      //	Constructor. Accepts the times of vertical and
      //	horizontal directions being open.
      CrossSemaphore (Time timeVertical, Time timeHorizontal);


    //## Other Operations (specified)
      //## Operation: accept%3EEB11F80244
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

      //## Operation: setTimes%3EEDDE790366
      //	Sets the times of vertical and horizontal directions
      //	being open.
      virtual void setTimes (Time timeVertical, Time timeHorizontal);

      //## Operation: getTimeVertical%3EEDDEA20046
      //	Returns the time of the vertical direction being open.
      virtual Time getTimeVertical ();

      //## Operation: getTimeHorizontal%3EEDDEC90348
      //	Returns the time of the horizontal direction being open.
      virtual Time getTimeHorizontal ();

      //## Operation: getCurDir%3EE0C373024E
      //	Returns the currenttly open direction: horizontal or
      //	vertical.
      virtual CrossDir getCurDir ();

      //## Operation: notify%3EE0C2E40046
      //	Redefined. Switches the direction of controlled Flow
      //	Sources.
      virtual void notify (ID 	// Auxiliary identification of the event.
      );

    // Data Members for Associations

      //## Association: Traffic Modeling and Simulation::Concepts::Modeling Concepts::horizontal%3EE0C4410014
      //## Role: CrossSemaphore::horSource%3EE0C44402EE
      //## begin CrossSemaphore::horSource%3EE0C44402EE.role preserve=no  public: IFlowSource { -> 0..2RFHAN}
      IFlowSource *  horSource[2];
      //## end CrossSemaphore::horSource%3EE0C44402EE.role

      //## Association: Traffic Modeling and Simulation::Concepts::Modeling Concepts::vertical%3EE0C47B0082
      //## Role: CrossSemaphore::verSource%3EE0C4810000
      //## begin CrossSemaphore::verSource%3EE0C4810000.role preserve=no  public: IFlowSource { -> 0..2RFHAN}
      IFlowSource *  verSource[2];
      //## end CrossSemaphore::verSource%3EE0C4810000.role

    // Additional Public Declarations
      //## begin CrossSemaphore%3EE0C298014A.public preserve=yes
      //## end CrossSemaphore%3EE0C298014A.public

  protected:
    // Additional Protected Declarations
      //## begin CrossSemaphore%3EE0C298014A.protected preserve=yes
      //## end CrossSemaphore%3EE0C298014A.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: curDir%3EE0C32D0122
      //	Currently open direction: horizontal or vertical.
      //	enum CrossDir {horizontal, vertical};
      //## begin CrossSemaphore::curDir%3EE0C32D0122.attr preserve=no  private: CrossDir {UA} horizontal
      CrossDir curDir;
      //## end CrossSemaphore::curDir%3EE0C32D0122.attr

      //## Attribute: tVer%3EEDDDC0010E
      //	The time of the vertical direction being open.
      //## begin CrossSemaphore::tVer%3EEDDDC0010E.attr preserve=no  private: Time {UA} 1
      Time tVer;
      //## end CrossSemaphore::tVer%3EEDDDC0010E.attr

      //## Attribute: tHor%3EEDDDF602F8
      //	The time of the horizontal direction being open.
      //## begin CrossSemaphore::tHor%3EEDDDF602F8.attr preserve=no  private: Time {UA} 1
      Time tHor;
      //## end CrossSemaphore::tHor%3EEDDDF602F8.attr

    // Additional Private Declarations
      //## begin CrossSemaphore%3EE0C298014A.private preserve=yes
      //## end CrossSemaphore%3EE0C298014A.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin CrossSemaphore%3EE0C298014A.implementation preserve=yes
      //## end CrossSemaphore%3EE0C298014A.implementation

};

//## begin CrossSemaphore%3EE0C298014A.postscript preserve=yes
//## end CrossSemaphore%3EE0C298014A.postscript

// Class CrossSemaphore 


//## Other Operations (inline)
inline void CrossSemaphore::setTimes (Time timeVertical, Time timeHorizontal)
{
  //## begin CrossSemaphore::setTimes%3EEDDE790366.body preserve=yes
	if (timeVertical>0 && timeHorizontal>0) {
		tVer = timeVertical;
		tHor = timeHorizontal;
	}
  //## end CrossSemaphore::setTimes%3EEDDE790366.body
}

inline Time CrossSemaphore::getTimeVertical ()
{
  //## begin CrossSemaphore::getTimeVertical%3EEDDEA20046.body preserve=yes
	return tVer;
  //## end CrossSemaphore::getTimeVertical%3EEDDEA20046.body
}

inline Time CrossSemaphore::getTimeHorizontal ()
{
  //## begin CrossSemaphore::getTimeHorizontal%3EEDDEC90348.body preserve=yes
	return tHor;
  //## end CrossSemaphore::getTimeHorizontal%3EEDDEC90348.body
}

inline CrossDir CrossSemaphore::getCurDir ()
{
  //## begin CrossSemaphore::getCurDir%3EE0C373024E.body preserve=yes
	return curDir;
  //## end CrossSemaphore::getCurDir%3EE0C373024E.body
}

//## begin module%3EEB401A0302.epilog preserve=yes
//## end module%3EEB401A0302.epilog


#endif
