//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3F4003AC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3F4003AC.cm

//## begin module%3EEB3F4003AC.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3F4003AC.cp

//## Module: FlowSource%3EEB3F4003AC; Package specification
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\FlowSource.h

#ifndef FlowSource_h
#define FlowSource_h 1

//## begin module%3EEB3F4003AC.additionalIncludes preserve=no
//## end module%3EEB3F4003AC.additionalIncludes

//## begin module%3EEB3F4003AC.includes preserve=yes
#include "AbstractConcepts.h"
//## end module%3EEB3F4003AC.includes

//## begin module%3EEB3F4003AC.declarations preserve=no
//## end module%3EEB3F4003AC.declarations

//## begin module%3EEB3F4003AC.additionalDeclarations preserve=yes
//## end module%3EEB3F4003AC.additionalDeclarations


//## begin FlowSource%3EE087670140.preface preserve=yes
//## end FlowSource%3EE087670140.preface

//## Class: FlowSource%3EE087670140
//	Source of discrete random traffic flow with exponential
//	distribution.
//## Category: Traffic Modeling and Simulation::Concepts::Modeling Concepts%3EE0C1CA01A4
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class FlowSource : public RandomTimedFlowElement, //## Inherits: <unnamed>%3EE0926B035C
                   	public IFlowSource  //## Inherits: <unnamed>%3EEDD5FD0154
{
  //## begin FlowSource%3EE087670140.initialDeclarations preserve=yes
  //## end FlowSource%3EE087670140.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: FlowSource%3EE0A61E01CC
      //	Constructor. Accepts a mean value of the exponential
      //	distribution. Creates an Exponential Random Generator
      //	and passes it to the constructor of the base class.
      //	Generates an initial vehicle occurrence.
      FlowSource (double meanValue = 1);


    //## Other Operations (specified)
      //## Operation: accept%3EEB11550348
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

      //## Operation: acceptFlow%3EE092860226
      //	Redefined. Does nothing (ignores input flow).
      virtual void acceptFlow ();

      //## Operation: notify%3EE0929902D0
      //	Redefined. Generates a new vehicle occurrence on its
      //	output and raises a new Event for another occurrence.
      virtual void notify (ID 	// Auxiliary identification of the event.
      );

      //## Operation: switchOn%3EE0A5C9010E
      //	Switch the source on - the source can generate or
      //	transport the flow.
      virtual void switchOn ();

      //## Operation: switchOff%3EE0A5C90140
      //	Switch the source off - the source does not generate or
      //	transport the flow any more.
      virtual void switchOff ();

      //## Operation: isOn%3EE0A5E60140
      //	Is the source switched on?
      virtual bool isOn ();

    // Additional Public Declarations
      //## begin FlowSource%3EE087670140.public preserve=yes
      //## end FlowSource%3EE087670140.public

  protected:
    // Additional Protected Declarations
      //## begin FlowSource%3EE087670140.protected preserve=yes
      //## end FlowSource%3EE087670140.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: onOff%3EE0A5EC0212
      //	On/off switch of the source.
      //## begin FlowSource::onOff%3EE0A5EC0212.attr preserve=no  private: bool {UA} true
      bool onOff;
      //## end FlowSource::onOff%3EE0A5EC0212.attr

    // Additional Private Declarations
      //## begin FlowSource%3EE087670140.private preserve=yes
      //## end FlowSource%3EE087670140.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin FlowSource%3EE087670140.implementation preserve=yes
      //## end FlowSource%3EE087670140.implementation

};

//## begin FlowSource%3EE087670140.postscript preserve=yes
//## end FlowSource%3EE087670140.postscript

// Class FlowSource 


//## Other Operations (inline)
inline void FlowSource::acceptFlow ()
{
  //## begin FlowSource::acceptFlow%3EE092860226.body preserve=yes
  //## end FlowSource::acceptFlow%3EE092860226.body
}

inline void FlowSource::switchOn ()
{
  //## begin FlowSource::switchOn%3EE0A5C9010E.body preserve=yes
	onOff = true;
  //## end FlowSource::switchOn%3EE0A5C9010E.body
}

inline void FlowSource::switchOff ()
{
  //## begin FlowSource::switchOff%3EE0A5C90140.body preserve=yes
	onOff = false;
  //## end FlowSource::switchOff%3EE0A5C90140.body
}

inline bool FlowSource::isOn ()
{
  //## begin FlowSource::isOn%3EE0A5E60140.body preserve=yes
	return onOff;
  //## end FlowSource::isOn%3EE0A5E60140.body
}

//## begin module%3EEB3F4003AC.epilog preserve=yes
//## end module%3EEB3F4003AC.epilog


#endif
