//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3F98010E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3F98010E.cm

//## begin module%3EEB3F98010E.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3F98010E.cp

//## Module: Pipe%3EEB3F98010E; Package specification
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\Pipe.h

#ifndef Pipe_h
#define Pipe_h 1

//## begin module%3EEB3F98010E.additionalIncludes preserve=no
//## end module%3EEB3F98010E.additionalIncludes

//## begin module%3EEB3F98010E.includes preserve=yes
#include "AbstractConcepts.h"
//## end module%3EEB3F98010E.includes

//## begin module%3EEB3F98010E.declarations preserve=no
//## end module%3EEB3F98010E.declarations

//## begin module%3EEB3F98010E.additionalDeclarations preserve=yes
//## end module%3EEB3F98010E.additionalDeclarations


//## begin Pipe%3EE0AA9501FE.preface preserve=yes
//## end Pipe%3EE0AA9501FE.preface

//## Class: Pipe%3EE0AA9501FE
//	A pipe of flow with a random delay of the pass of each
//	vehicle occurrence. The transportation delay has an
//	exponential distribution.
//## Category: Traffic Modeling and Simulation::Concepts::Modeling Concepts%3EE0C1CA01A4
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class Pipe : public RandomTimedFlowElement  //## Inherits: <unnamed>%3EE0B0300294
{
  //## begin Pipe%3EE0AA9501FE.initialDeclarations preserve=yes
  //## end Pipe%3EE0AA9501FE.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: Pipe%3EE0AB2E0096
      //	Constructor. Accepts the mean value of the exponential
      //	distribution. Creates an Exponential Random Generator
      //	and passes it to the constructor of the base class.
      Pipe (double meanValue = 1);


    //## Other Operations (specified)
      //## Operation: accept%3EEB11BB01C2
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

      //## Operation: notify%3EE0AFE00169
      //	Redefined. Generates a new vehicle occurrence on its
      //	output.
      virtual void notify (ID 	// Auxiliary identification of the event.
      );

    // Additional Public Declarations
      //## begin Pipe%3EE0AA9501FE.public preserve=yes
      //## end Pipe%3EE0AA9501FE.public

  protected:

    //## Other Operations (specified)
      //## Operation: process%3EE0AFE00168
      //	Redefined. Transports a vehicle with a random delay by
      //	raising an Event.
      virtual void process ();

    // Additional Protected Declarations
      //## begin Pipe%3EE0AA9501FE.protected preserve=yes
      //## end Pipe%3EE0AA9501FE.protected

  private:
    // Additional Private Declarations
      //## begin Pipe%3EE0AA9501FE.private preserve=yes
      //## end Pipe%3EE0AA9501FE.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin Pipe%3EE0AA9501FE.implementation preserve=yes
      //## end Pipe%3EE0AA9501FE.implementation

};

//## begin Pipe%3EE0AA9501FE.postscript preserve=yes
//## end Pipe%3EE0AA9501FE.postscript

// Class Pipe 

//## begin module%3EEB3F98010E.epilog preserve=yes
//## end module%3EEB3F98010E.epilog


#endif
