//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3FD2006E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3FD2006E.cm

//## begin module%3EEB3FD2006E.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3FD2006E.cp

//## Module: QueServer%3EEB3FD2006E; Package body
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\QueServer.cpp

//## begin module%3EEB3FD2006E.additionalIncludes preserve=no
//## end module%3EEB3FD2006E.additionalIncludes

//## begin module%3EEB3FD2006E.includes preserve=yes
#include "Visitor.h"
#include "ExpRndGen.h"
//## end module%3EEB3FD2006E.includes

// QueServer
#include "QueServer.h"
//## begin module%3EEB3FD2006E.declarations preserve=no
//## end module%3EEB3FD2006E.declarations

//## begin module%3EEB3FD2006E.additionalDeclarations preserve=yes
//## end module%3EEB3FD2006E.additionalDeclarations


// Class QueuedServer 





QueuedServer::QueuedServer (double meanValue)
  //## begin QueuedServer::QueuedServer%3EE0B5480280.hasinit preserve=no
      : onOff(true),
        queSize(0),
        isServing(false),
        maxQueSize(0)
  //## end QueuedServer::QueuedServer%3EE0B5480280.hasinit
  //## begin QueuedServer::QueuedServer%3EE0B5480280.initialization preserve=yes
  , RandomTimedFlowElement(new ExpGenerator(meanValue))
  //## end QueuedServer::QueuedServer%3EE0B5480280.initialization
{
  //## begin QueuedServer::QueuedServer%3EE0B5480280.body preserve=yes
  //## end QueuedServer::QueuedServer%3EE0B5480280.body
}



//## Other Operations (implementation)
void QueuedServer::accept (Visitor* vis)
{
  //## begin QueuedServer::accept%3EEB11C801D6.body preserve=yes
	if (vis) vis->visitQueuedServer(this);
  //## end QueuedServer::accept%3EEB11C801D6.body
}

void QueuedServer::process ()
{
  //## begin QueuedServer::process%3EE0B5480281.body preserve=yes
	if (isOn() && !isServing && queSize==0) {
		isServing = true;
		raiseEvent();
	} else {
		queSize++;
		if (queSize>maxQueSize) maxQueSize = queSize;
	}
  //## end QueuedServer::process%3EE0B5480281.body
}

void QueuedServer::notify (ID )
{
  //## begin QueuedServer::notify%3EE0B54802BC.body preserve=yes
	isServing = false;
	send();
	if (isOn() && !isServing && queSize>0) {
		queSize--;
		isServing = true;
		raiseEvent();
	}
  //## end QueuedServer::notify%3EE0B54802BC.body
}

void QueuedServer::switchOn ()
{
  //## begin QueuedServer::switchOn%3EE0B5B8035C.body preserve=yes
	onOff = true;
	if (isOn() && !isServing && queSize>0) {
		queSize--;
		isServing = true;
		raiseEvent();
	}
  //## end QueuedServer::switchOn%3EE0B5B8035C.body
}

// Additional Declarations
  //## begin QueuedServer%3EE0B4A0023A.declarations preserve=yes
  //## end QueuedServer%3EE0B4A0023A.declarations

//## begin module%3EEB3FD2006E.epilog preserve=yes
//## end module%3EEB3FD2006E.epilog
