//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3FBE0186.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3FBE0186.cm

//## begin module%3EEB3FBE0186.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3FBE0186.cp

//## Module: QueServer%3EEB3FBE0186; Package specification
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\QueServer.h

#ifndef QueServer_h
#define QueServer_h 1

//## begin module%3EEB3FBE0186.additionalIncludes preserve=no
//## end module%3EEB3FBE0186.additionalIncludes

//## begin module%3EEB3FBE0186.includes preserve=yes
#include "AbstractConcepts.h"
//## end module%3EEB3FBE0186.includes

//## begin module%3EEB3FBE0186.declarations preserve=no
//## end module%3EEB3FBE0186.declarations

//## begin module%3EEB3FBE0186.additionalDeclarations preserve=yes
//## end module%3EEB3FBE0186.additionalDeclarations


//## begin QueuedServer%3EE0B4A0023A.preface preserve=yes
//## end QueuedServer%3EE0B4A0023A.preface

//## Class: QueuedServer%3EE0B4A0023A
//	A server that processes occurrences with a random delay,
//	and with an unbounded queue in front. The service delay
//	has an exponential distribution. The on/off 'gate' is in
//	front of the server, i.e., it opens and closes the
//	entrance to the server from the queue.
//## Category: Traffic Modeling and Simulation::Concepts::Modeling Concepts%3EE0C1CA01A4
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class QueuedServer : public RandomTimedFlowElement, //## Inherits: <unnamed>%3EE0B67203B6
                     	public IFlowSource  //## Inherits: <unnamed>%3EEDDCC0010E
{
  //## begin QueuedServer%3EE0B4A0023A.initialDeclarations preserve=yes
  //## end QueuedServer%3EE0B4A0023A.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: QueuedServer%3EE0B5480280
      //	Constructor.  Accepts the mean value of the exponential
      //	distribution. Creates an Exponential Random Generator
      //	and passes it to the constructor of the base class.
      QueuedServer (double meanValue = 1);


    //## Other Operations (specified)
      //## Operation: accept%3EEB11C801D6
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

      //## Operation: notify%3EE0B54802BC
      //	Redefined. Generates a new vehicle occurrence on its
      //	output, and takes another one to the server, if the
      //	queue is not empty (by reaising an Event).
      virtual void notify (ID 	// Auxiliary identification of the event.
      );

      //## Operation: switchOn%3EE0B5B8035C
      //	Switch the source on - the server can serve the flow.
      virtual void switchOn ();

      //## Operation: switchOff%3EE0B5B8038E
      //	Switch the source off - the server does not serve the
      //	flow any more.
      virtual void switchOff ();

      //## Operation: isOn%3EE0B5B803CA
      //	Is the server switched on?
      virtual bool isOn ();

      //## Operation: isCurrentlyServing%3EEF790900D2
      //	Is the server currently serving?
      virtual bool isCurrentlyServing ();

      //## Operation: getQueueSize%3EE0B65001C2
      //	Returns the number of the queued vehicles.
      virtual unsigned long getQueueSize ();

      //## Operation: getMaxQueueSize%3EEF5A7B0064
      //	Returns the maximal recorded number of the queued
      //	vehicles.
      virtual unsigned long getMaxQueueSize ();

    // Additional Public Declarations
      //## begin QueuedServer%3EE0B4A0023A.public preserve=yes
      //## end QueuedServer%3EE0B4A0023A.public

  protected:

    //## Other Operations (specified)
      //## Operation: process%3EE0B5480281
      //	Redefined. Puts a vehicle in the queue, and passes it to
      //	the server if it is idle (by raising an Event).
      virtual void process ();

    // Additional Protected Declarations
      //## begin QueuedServer%3EE0B4A0023A.protected preserve=yes
      //## end QueuedServer%3EE0B4A0023A.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: onOff%3EE0B5E20334
      //	On/off switch of the server.
      //## begin QueuedServer::onOff%3EE0B5E20334.attr preserve=no  private: bool {UA} true
      bool onOff;
      //## end QueuedServer::onOff%3EE0B5E20334.attr

      //## Attribute: queSize%3EE0B6330078
      //	Current size of the queue.
      //## begin QueuedServer::queSize%3EE0B6330078.attr preserve=no  private: unsigned long {UA} 0
      unsigned long queSize;
      //## end QueuedServer::queSize%3EE0B6330078.attr

      //## Attribute: isServing%3EEDE3350244
      //	Is the server serving an occurrence.
      //## begin QueuedServer::isServing%3EEDE3350244.attr preserve=no  private: bool {UA} false
      bool isServing;
      //## end QueuedServer::isServing%3EEDE3350244.attr

      //## Attribute: maxQueSize%3EEF5A4803B6
      //	The maximal recorded queue size.
      //## begin QueuedServer::maxQueSize%3EEF5A4803B6.attr preserve=no  private: unsigned long {UA} 0
      unsigned long maxQueSize;
      //## end QueuedServer::maxQueSize%3EEF5A4803B6.attr

    // Additional Private Declarations
      //## begin QueuedServer%3EE0B4A0023A.private preserve=yes
      //## end QueuedServer%3EE0B4A0023A.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin QueuedServer%3EE0B4A0023A.implementation preserve=yes
      //## end QueuedServer%3EE0B4A0023A.implementation

};

//## begin QueuedServer%3EE0B4A0023A.postscript preserve=yes
//## end QueuedServer%3EE0B4A0023A.postscript

// Class QueuedServer 


//## Other Operations (inline)
inline void QueuedServer::switchOff ()
{
  //## begin QueuedServer::switchOff%3EE0B5B8038E.body preserve=yes
	onOff = false;
  //## end QueuedServer::switchOff%3EE0B5B8038E.body
}

inline bool QueuedServer::isOn ()
{
  //## begin QueuedServer::isOn%3EE0B5B803CA.body preserve=yes
	return onOff;
  //## end QueuedServer::isOn%3EE0B5B803CA.body
}

inline bool QueuedServer::isCurrentlyServing ()
{
  //## begin QueuedServer::isCurrentlyServing%3EEF790900D2.body preserve=yes
	return isServing;
  //## end QueuedServer::isCurrentlyServing%3EEF790900D2.body
}

inline unsigned long QueuedServer::getQueueSize ()
{
  //## begin QueuedServer::getQueueSize%3EE0B65001C2.body preserve=yes
	return queSize;
  //## end QueuedServer::getQueueSize%3EE0B65001C2.body
}

inline unsigned long QueuedServer::getMaxQueueSize ()
{
  //## begin QueuedServer::getMaxQueueSize%3EEF5A7B0064.body preserve=yes
	return maxQueSize;
  //## end QueuedServer::getMaxQueueSize%3EEF5A7B0064.body
}

//## begin module%3EEB3FBE0186.epilog preserve=yes
//## end module%3EEB3FBE0186.epilog


#endif
