//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB400B00E6.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB400B00E6.cm

//## begin module%3EEB400B00E6.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB400B00E6.cp

//## Module: Switch1to3%3EEB400B00E6; Package body
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\Switch1to3.cpp

//## begin module%3EEB400B00E6.additionalIncludes preserve=no
//## end module%3EEB400B00E6.additionalIncludes

//## begin module%3EEB400B00E6.includes preserve=yes
#include "Visitor.h"
//## end module%3EEB400B00E6.includes

// UniRndGen
#include "UniRndGen.h"
// Switch1to3
#include "Switch1to3.h"


//## begin module%3EEB400B00E6.declarations preserve=no
//## end module%3EEB400B00E6.declarations

//## begin module%3EEB400B00E6.additionalDeclarations preserve=yes
//## end module%3EEB400B00E6.additionalDeclarations


// Class Switch1to3 






Switch1to3::Switch1to3 (double leftTurnProb, double rightTurnProb)
  //## begin Switch1to3::Switch1to3%3EE0BB7801E0.hasinit preserve=no
      : ltProb(0.0),
        rtProb(0.0)
  //## end Switch1to3::Switch1to3%3EE0BB7801E0.hasinit
  //## begin Switch1to3::Switch1to3%3EE0BB7801E0.initialization preserve=yes
  , leftTarget(0), rightTarget(0), rndGen(new UniformGenerator())
  //## end Switch1to3::Switch1to3%3EE0BB7801E0.initialization
{
  //## begin Switch1to3::Switch1to3%3EE0BB7801E0.body preserve=yes
	setProbabilities(leftTurnProb,rightTurnProb);
  //## end Switch1to3::Switch1to3%3EE0BB7801E0.body
}


Switch1to3::~Switch1to3 ()
{
  //## begin Switch1to3::~Switch1to3%3EEB2645038E.body preserve=yes
	delete rndGen;
  //## end Switch1to3::~Switch1to3%3EEB2645038E.body
}



//## Other Operations (implementation)
void Switch1to3::accept (Visitor* vis)
{
  //## begin Switch1to3::accept%3EEB11E30226.body preserve=yes
	if (vis) vis->visitSwitch1to3(this);
  //## end Switch1to3::accept%3EEB11E30226.body
}

void Switch1to3::process ()
{
  //## begin Switch1to3::process%3EE0BB780212.body preserve=yes
	if (rndGen==0) {
		send();
		return;
	}
	double rnd = rndGen->getRandom();
	if (rnd<ltProb) {
		if (leftTarget) leftTarget->acceptFlow();
		return;
	}
	if (rnd<ltProb+rtProb) {
		if (rightTarget) rightTarget->acceptFlow();
		return;
	}
	send();
  //## end Switch1to3::process%3EE0BB780212.body
}

void Switch1to3::setProbabilities (double leftTurnProb, double rightTurnProb)
{
  //## begin Switch1to3::setProbabilities%3EE0BC3E021C.body preserve=yes
	if (leftTurnProb>=0.0 && leftTurnProb<=1.0 &&
		rightTurnProb>=0.0 && rightTurnProb<=1.0 &&
		leftTurnProb+rightTurnProb<=1.0) {
		ltProb = leftTurnProb;
		rtProb = rightTurnProb;
	}
  //## end Switch1to3::setProbabilities%3EE0BC3E021C.body
}

// Additional Declarations
  //## begin Switch1to3%3EE0AF8D0244.declarations preserve=yes
  //## end Switch1to3%3EE0AF8D0244.declarations

//## begin module%3EEB400B00E6.epilog preserve=yes
//## end module%3EEB400B00E6.epilog
