//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3FF8000A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3FF8000A.cm

//## begin module%3EEB3FF8000A.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3FF8000A.cp

//## Module: Switch1to3%3EEB3FF8000A; Package specification
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\Switch1to3.h

#ifndef Switch1to3_h
#define Switch1to3_h 1

//## begin module%3EEB3FF8000A.additionalIncludes preserve=no
//## end module%3EEB3FF8000A.additionalIncludes

//## begin module%3EEB3FF8000A.includes preserve=yes
#include "AbstractConcepts.h"
//## end module%3EEB3FF8000A.includes

//## begin module%3EEB3FF8000A.declarations preserve=no
//## end module%3EEB3FF8000A.declarations

//## begin module%3EEB3FF8000A.additionalDeclarations preserve=yes
class UniformGenerator;
//## end module%3EEB3FF8000A.additionalDeclarations


//## begin Switch1to3%3EE0AF8D0244.preface preserve=yes
//## end Switch1to3%3EE0AF8D0244.preface

//## Class: Switch1to3%3EE0AF8D0244
//	Switch with one input and three outputs: straight, left,
//	and right. Randomly passes the input flow to the three
//	directions, according to the defined probabilities of
//	turns with a uniform distribution.
//## Category: Traffic Modeling and Simulation::Concepts::Modeling Concepts%3EE0C1CA01A4
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class Switch1to3 : public FlowElement  //## Inherits: <unnamed>%3EE0BCD100F0
{
  //## begin Switch1to3%3EE0AF8D0244.initialDeclarations preserve=yes
  //## end Switch1to3%3EE0AF8D0244.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: Switch1to3%3EE0BB7801E0
      //	Constructor. Accepts the probabilities of left and right
      //	turns (they must be in [0..1] and their sum must be in
      //	[0..1]). Creates a Uniform Random Generator.
      Switch1to3 (double leftTurnProb = 0.0, double rightTurnProb = 0.0);


    //## Other Operations (specified)
      //## Operation: accept%3EEB11E30226
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

      //## Operation: getLTProb%3EE0BC0D0064
      //	Returns the left-turn probability.
      virtual double getLTProb ();

      //## Operation: getRTProb%3EE0BC3E01E0
      //	Returns the right-turn probability.
      virtual double getRTProb ();

      //## Operation: setProbabilities%3EE0BC3E021C
      //	Sets the left-turn and right-turn probabilities. Accepts
      //	the probabilities of left and right turns. They must be
      //	in [0..1] and their sum must be in [0..1].
      virtual void setProbabilities (double leftTurnProb = 0.0, double rightTurnProb = 0.0);

    // Data Members for Associations

      //## Association: Traffic Modeling and Simulation::Concepts::Modeling Concepts::leftTurn%3EE0BD0A03CA
      //## Role: Switch1to3::leftTarget%3EE0BD0E01AE
      //## begin Switch1to3::leftTarget%3EE0BD0E01AE.role preserve=no  public: FlowElement {n -> 0..1RFHAN}
      FlowElement *leftTarget;
      //## end Switch1to3::leftTarget%3EE0BD0E01AE.role

      //## Association: Traffic Modeling and Simulation::Concepts::Modeling Concepts::rightTurn%3EE0BD63026C
      //## Role: Switch1to3::rightTarget%3EE0BD660212
      //## begin Switch1to3::rightTarget%3EE0BD660212.role preserve=no  public: FlowElement {* -> 0..1RFHAN}
      FlowElement *rightTarget;
      //## end Switch1to3::rightTarget%3EE0BD660212.role

    // Additional Public Declarations
      //## begin Switch1to3%3EE0AF8D0244.public preserve=yes
      //## end Switch1to3%3EE0AF8D0244.public

  protected:
    //## Destructor (specified)
      //## Operation: ~Switch1to3%3EEB2645038E
      //	Destructor. Destroys its Uniform Random Generator.
      virtual ~Switch1to3 ();


    //## Other Operations (specified)
      //## Operation: process%3EE0BB780212
      //	Redefined. Passes the occurrence to the straight, left,
      //	or right target randomly, according to the given
      //	probabilities of turns.
      virtual void process ();

    // Additional Protected Declarations
      //## begin Switch1to3%3EE0AF8D0244.protected preserve=yes
      //## end Switch1to3%3EE0AF8D0244.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: ltProb%3EE0BBE5003C
      //	Left turn probability.
      //## begin Switch1to3::ltProb%3EE0BBE5003C.attr preserve=no  private: double {UA} 0.0
      double ltProb;
      //## end Switch1to3::ltProb%3EE0BBE5003C.attr

      //## Attribute: rtProb%3EE0BBF8030C
      //	Right turn probability.
      //## begin Switch1to3::rtProb%3EE0BBF8030C.attr preserve=no  private: double {UA} 0.0
      double rtProb;
      //## end Switch1to3::rtProb%3EE0BBF8030C.attr

    // Data Members for Associations

      //## Association: Traffic Modeling and Simulation::Concepts::Modeling Concepts::<unnamed>%3EE0AAEC0190
      //## Role: Switch1to3::rndGen%3EE0AAEC0384
      //## begin Switch1to3::rndGen%3EE0AAEC0384.role preserve=no  private: UniformGenerator {0..1 -> 1VFHgAN}
      UniformGenerator *rndGen;
      //## end Switch1to3::rndGen%3EE0AAEC0384.role

    // Additional Private Declarations
      //## begin Switch1to3%3EE0AF8D0244.private preserve=yes
      //## end Switch1to3%3EE0AF8D0244.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin Switch1to3%3EE0AF8D0244.implementation preserve=yes
      //## end Switch1to3%3EE0AF8D0244.implementation

};

//## begin Switch1to3%3EE0AF8D0244.postscript preserve=yes
//## end Switch1to3%3EE0AF8D0244.postscript

// Class Switch1to3 


//## Other Operations (inline)
inline double Switch1to3::getLTProb ()
{
  //## begin Switch1to3::getLTProb%3EE0BC0D0064.body preserve=yes
	return ltProb;
  //## end Switch1to3::getLTProb%3EE0BC0D0064.body
}

inline double Switch1to3::getRTProb ()
{
  //## begin Switch1to3::getRTProb%3EE0BC3E01E0.body preserve=yes
	return rtProb;
  //## end Switch1to3::getRTProb%3EE0BC3E01E0.body
}

//## begin module%3EEB3FF8000A.epilog preserve=yes
//## end module%3EEB3FF8000A.epilog


#endif
