//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3EDC0366.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3EDC0366.cm

//## begin module%3EEB3EDC0366.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3EDC0366.cp

//## Module: ExpRndGen%3EEB3EDC0366; Package specification
//## Subsystem: Concepts::Random Generators%3EEC42730370
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Random Generators\ExpRndGen.h

#ifndef ExpRndGen_h
#define ExpRndGen_h 1

//## begin module%3EEB3EDC0366.additionalIncludes preserve=no
//## end module%3EEB3EDC0366.additionalIncludes

//## begin module%3EEB3EDC0366.includes preserve=yes
#include "RndGen.h"
//## end module%3EEB3EDC0366.includes

//## begin module%3EEB3EDC0366.declarations preserve=no
//## end module%3EEB3EDC0366.declarations

//## begin module%3EEB3EDC0366.additionalDeclarations preserve=yes
//## end module%3EEB3EDC0366.additionalDeclarations


//## begin ExpGenerator%3EE08FCE024E.preface preserve=yes
//## end ExpGenerator%3EE08FCE024E.preface

//## Class: ExpGenerator%3EE08FCE024E
//	Random number generator of an exponential distribution.
//## Category: Traffic Modeling and Simulation::Concepts::Random Generators%3EE0C1750262
//## Subsystem: Concepts::Random Generators%3EEC42730370
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class ExpGenerator : public RandomGenerator  //## Inherits: <unnamed>%3EE08FF6012C
{
  //## begin ExpGenerator%3EE08FCE024E.initialDeclarations preserve=yes
  //## end ExpGenerator%3EE08FCE024E.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: ExpGenerator%3EE8EF7B01A4
      //	Constructor. Accepts the mean value of the distribution.
      ExpGenerator (double meanValue = 1);


    //## Other Operations (specified)
      //## Operation: accept%3EEB10FB00A0
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

      //## Operation: getDistributionName%3EEB1A5402BC
      //	Redefined. Returns the name of distribution of the
      //	generator.
      virtual String getDistributionName ();

      //## Operation: getMeanValue%3EE8EF7B01D8
      //	Redefined. Returns the mean value of the distribution.
      virtual double getMeanValue ();

    // Additional Public Declarations
      //## begin ExpGenerator%3EE08FCE024E.public preserve=yes
      //## end ExpGenerator%3EE08FCE024E.public

  protected:

    //## Other Operations (specified)
      //## Operation: convert%3EE8EF7B01D6
      //	Redefined. Converts the given random number x with the
      //	uniform distribution in [0..1] into a random number with
      //	the exponential distribution.
      virtual double convert (double x);

    // Additional Protected Declarations
      //## begin ExpGenerator%3EE08FCE024E.protected preserve=yes
      //## end ExpGenerator%3EE08FCE024E.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: mean%3EE8EF52033E
      //	The mean value of the distribution.
      //## begin ExpGenerator::mean%3EE8EF52033E.attr preserve=no  private: double {UA} meanValue
      double mean;
      //## end ExpGenerator::mean%3EE8EF52033E.attr

    // Additional Private Declarations
      //## begin ExpGenerator%3EE08FCE024E.private preserve=yes
      //## end ExpGenerator%3EE08FCE024E.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin ExpGenerator%3EE08FCE024E.implementation preserve=yes
      //## end ExpGenerator%3EE08FCE024E.implementation

};

//## begin ExpGenerator%3EE08FCE024E.postscript preserve=yes
//## end ExpGenerator%3EE08FCE024E.postscript

// Class ExpGenerator 

inline ExpGenerator::ExpGenerator (double meanValue)
  //## begin ExpGenerator::ExpGenerator%3EE8EF7B01A4.hasinit preserve=no
      : mean(meanValue)
  //## end ExpGenerator::ExpGenerator%3EE8EF7B01A4.hasinit
  //## begin ExpGenerator::ExpGenerator%3EE8EF7B01A4.initialization preserve=yes
  //## end ExpGenerator::ExpGenerator%3EE8EF7B01A4.initialization
{
  //## begin ExpGenerator::ExpGenerator%3EE8EF7B01A4.body preserve=yes
  //## end ExpGenerator::ExpGenerator%3EE8EF7B01A4.body
}



//## Other Operations (inline)
inline String ExpGenerator::getDistributionName ()
{
  //## begin ExpGenerator::getDistributionName%3EEB1A5402BC.body preserve=yes
	return "Exponential";
  //## end ExpGenerator::getDistributionName%3EEB1A5402BC.body
}

inline double ExpGenerator::getMeanValue ()
{
  //## begin ExpGenerator::getMeanValue%3EE8EF7B01D8.body preserve=yes
	return mean;
  //## end ExpGenerator::getMeanValue%3EE8EF7B01D8.body
}

//## begin module%3EEB3EDC0366.epilog preserve=yes
//## end module%3EEB3EDC0366.epilog


#endif
