//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3EAA00DC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3EAA00DC.cm

//## begin module%3EEB3EAA00DC.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3EAA00DC.cp

//## Module: RndGen%3EEB3EAA00DC; Package body
//## Subsystem: Concepts::Random Generators%3EEC42730370
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Random Generators\RndGen.cpp

//## begin module%3EEB3EAA00DC.additionalIncludes preserve=no
//## end module%3EEB3EAA00DC.additionalIncludes

//## begin module%3EEB3EAA00DC.includes preserve=yes
#include <math.h>

#include "Visitor.h"
//## end module%3EEB3EAA00DC.includes

// UniRndGen
#include "UniRndGen.h"
// RndGen
#include "RndGen.h"
// ExpRndGen
#include "ExpRndGen.h"
//## begin module%3EEB3EAA00DC.declarations preserve=no
//## end module%3EEB3EAA00DC.declarations

//## begin module%3EEB3EAA00DC.additionalDeclarations preserve=yes
const unsigned long urndSeed = 2901970UL;
//## end module%3EEB3EAA00DC.additionalDeclarations


// Class RandomGenerator 

//## begin RandomGenerator::urndNum%3EE981B40050.attr preserve=no  private: static unsigned long {UA} urndSeed
unsigned long RandomGenerator::urndNum = urndSeed;
//## end RandomGenerator::urndNum%3EE981B40050.attr



//## Other Operations (implementation)
double RandomGenerator::getRandom ()
{
  //## begin RandomGenerator::getRandom%3EE08EEC03C0.body preserve=yes
	double r = urnd();
	return convert(r);
  //## end RandomGenerator::getRandom%3EE08EEC03C0.body
}

double RandomGenerator::urnd ()
{
  //## begin RandomGenerator::urnd%3EE8EB6B0384.body preserve=yes
	urndNum = (314159261UL * urndNum + 907633385UL); // % 4294967296UL; provided that unsigned long is 32 bits
	return urndNum / 4294967296.0;
  //## end RandomGenerator::urnd%3EE8EB6B0384.body
}

// Additional Declarations
  //## begin RandomGenerator%3EE08ED4026C.declarations preserve=yes
  //## end RandomGenerator%3EE08ED4026C.declarations

// Class UniformGenerator 





//## Other Operations (implementation)
void UniformGenerator::accept (Visitor* vis)
{
  //## begin UniformGenerator::accept%3EEB10AC0230.body preserve=yes
	if (vis) vis->visitUniformGenerator(this);
  //## end UniformGenerator::accept%3EEB10AC0230.body
}

double UniformGenerator::convert (double x)
{
  //## begin UniformGenerator::convert%3EE8EDB70302.body preserve=yes
	return x*(upper-lower)+lower;
  //## end UniformGenerator::convert%3EE8EDB70302.body
}

// Additional Declarations
  //## begin UniformGenerator%3EE0A9C8001E.declarations preserve=yes
  //## end UniformGenerator%3EE0A9C8001E.declarations

// Class ExpGenerator 



//## Other Operations (implementation)
void ExpGenerator::accept (Visitor* vis)
{
  //## begin ExpGenerator::accept%3EEB10FB00A0.body preserve=yes
	if (vis) vis->visitExpGenerator(this);
  //## end ExpGenerator::accept%3EEB10FB00A0.body
}

double ExpGenerator::convert (double x)
{
  //## begin ExpGenerator::convert%3EE8EF7B01D6.body preserve=yes
	if (x>=1.0) x=0.0;
	return -mean*log(1.0-x);
  //## end ExpGenerator::convert%3EE8EF7B01D6.body
}

// Additional Declarations
  //## begin ExpGenerator%3EE08FCE024E.declarations preserve=yes
  //## end ExpGenerator%3EE08FCE024E.declarations

//## begin module%3EEB3EAA00DC.epilog preserve=yes
//## end module%3EEB3EAA00DC.epilog
