//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3E9902B2.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3E9902B2.cm

//## begin module%3EEB3E9902B2.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3E9902B2.cp

//## Module: RndGen%3EEB3E9902B2; Package specification
//## Subsystem: Concepts::Random Generators%3EEC42730370
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Random Generators\RndGen.h

#ifndef RndGen_h
#define RndGen_h 1

//## begin module%3EEB3E9902B2.additionalIncludes preserve=no
//## end module%3EEB3E9902B2.additionalIncludes

//## begin module%3EEB3E9902B2.includes preserve=yes
#include "Types.h"
//## end module%3EEB3E9902B2.includes

//## begin module%3EEB3E9902B2.declarations preserve=no
//## end module%3EEB3E9902B2.declarations

//## begin module%3EEB3E9902B2.additionalDeclarations preserve=yes
class Visitor;
//## end module%3EEB3E9902B2.additionalDeclarations


//## begin RandomGenerator%3EE08ED4026C.preface preserve=yes
//## end RandomGenerator%3EE08ED4026C.preface

//## Class: RandomGenerator%3EE08ED4026C; Abstract
//	Abstract generalization of random number generators.
//## Category: Traffic Modeling and Simulation::Concepts::Random Generators%3EE0C1750262
//## Subsystem: Concepts::Random Generators%3EEC42730370
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class RandomGenerator 
{
  //## begin RandomGenerator%3EE08ED4026C.initialDeclarations preserve=yes
  //## end RandomGenerator%3EE08ED4026C.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: accept%3EEB10710050
      //	Abstract. Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis) = 0;

      //## Operation: getDistributionName%3EEB19D300F0
      //	Abstract. Returns the name of distribution of the
      //	generator.
      virtual String getDistributionName () = 0;

      //## Operation: getMeanValue%3EE8EEBA0082
      //	Abstract. Returns the mean value of the distribution.
      virtual double getMeanValue () = 0;

      //## Operation: getRandom%3EE08EEC03C0
      //	Returns a newly generated random number. Final. First
      //	calls urnd() to generate a random number with the
      //	uniform distribution, and then calls the polymorphic
      //	operation convert() to convert the generated uniform
      //	number into a number with the desired distribution.
      //	Template Method DP.
      double getRandom ();

    // Additional Public Declarations
      //## begin RandomGenerator%3EE08ED4026C.public preserve=yes
      //## end RandomGenerator%3EE08ED4026C.public

  protected:

    //## Other Operations (specified)
      //## Operation: urnd%3EE8EB6B0384
      //	Static, helper. Returns a new random number in [0..1]
      //	with the uniform distribution.
      static double urnd ();

      //## Operation: convert%3EE8EB99010E
      //	Abstract. To be redefined in the derived classes.
      //	Converts the given random number x with the uniform
      //	distribution in [0..1] into a random number with the
      //	desired distribution.
      virtual double convert (double x) = 0;

    // Additional Protected Declarations
      //## begin RandomGenerator%3EE08ED4026C.protected preserve=yes
      //## end RandomGenerator%3EE08ED4026C.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: urndNum%3EE981B40050
      //	Static. The previously generated random number.
      //## begin RandomGenerator::urndNum%3EE981B40050.attr preserve=no  private: static unsigned long {UA} urndSeed
      static unsigned long urndNum;
      //## end RandomGenerator::urndNum%3EE981B40050.attr

    // Additional Private Declarations
      //## begin RandomGenerator%3EE08ED4026C.private preserve=yes
      //## end RandomGenerator%3EE08ED4026C.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin RandomGenerator%3EE08ED4026C.implementation preserve=yes
      //## end RandomGenerator%3EE08ED4026C.implementation

};

//## begin RandomGenerator%3EE08ED4026C.postscript preserve=yes
//## end RandomGenerator%3EE08ED4026C.postscript

// Class RandomGenerator 

//## begin module%3EEB3E9902B2.epilog preserve=yes
//## end module%3EEB3E9902B2.epilog


#endif
