//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3EBF02BC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3EBF02BC.cm

//## begin module%3EEB3EBF02BC.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3EBF02BC.cp

//## Module: UniRndGen%3EEB3EBF02BC; Package specification
//## Subsystem: Concepts::Random Generators%3EEC42730370
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Random Generators\UniRndGen.h

#ifndef UniRndGen_h
#define UniRndGen_h 1

//## begin module%3EEB3EBF02BC.additionalIncludes preserve=no
//## end module%3EEB3EBF02BC.additionalIncludes

//## begin module%3EEB3EBF02BC.includes preserve=yes
#include "RndGen.h"
//## end module%3EEB3EBF02BC.includes

//## begin module%3EEB3EBF02BC.declarations preserve=no
//## end module%3EEB3EBF02BC.declarations

//## begin module%3EEB3EBF02BC.additionalDeclarations preserve=yes
//## end module%3EEB3EBF02BC.additionalDeclarations


//## begin UniformGenerator%3EE0A9C8001E.preface preserve=yes
//## end UniformGenerator%3EE0A9C8001E.preface

//## Class: UniformGenerator%3EE0A9C8001E
//	Random number generator of a uniform distribution.
//## Category: Traffic Modeling and Simulation::Concepts::Random Generators%3EE0C1750262
//## Subsystem: Concepts::Random Generators%3EEC42730370
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class UniformGenerator : public RandomGenerator  //## Inherits: <unnamed>%3EE0A9C8005A
{
  //## begin UniformGenerator%3EE0A9C8001E.initialDeclarations preserve=yes
  //## end UniformGenerator%3EE0A9C8001E.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: UniformGenerator%3EE8EDCB0140
      //	Constructor. Accepts the lower and upper bounds of the
      //	range of random numbers with the uniform distribution.
      UniformGenerator (double lowerBound = 0, double upperBound = 1);


    //## Other Operations (specified)
      //## Operation: accept%3EEB10AC0230
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

      //## Operation: getDistributionName%3EEB1A290104
      //	Redefined. Returns the name of distribution of the
      //	generator.
      virtual String getDistributionName ();

      //## Operation: getMeanValue%3EE8EEDE0262
      //	Redefined. Returns the mean value of the distribution.
      virtual double getMeanValue ();

    // Additional Public Declarations
      //## begin UniformGenerator%3EE0A9C8001E.public preserve=yes
      //## end UniformGenerator%3EE0A9C8001E.public

  protected:

    //## Other Operations (specified)
      //## Operation: convert%3EE8EDB70302
      //	Redefined. Scales up the given random number x with the
      //	uniform distribution in [0..1] into a random number with
      //	the uniform distribution in [lower..upper].
      virtual double convert (double x);

    // Additional Protected Declarations
      //## begin UniformGenerator%3EE0A9C8001E.protected preserve=yes
      //## end UniformGenerator%3EE0A9C8001E.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: lower%3EE8ED7700AA
      //	The lower bound of the range of random numbers.
      //## begin UniformGenerator::lower%3EE8ED7700AA.attr preserve=no  private: double {UA} lowerBound
      double lower;
      //## end UniformGenerator::lower%3EE8ED7700AA.attr

      //## Attribute: upper%3EE8EDA30226
      //	The upper bound of the range of random numbers.
      //## begin UniformGenerator::upper%3EE8EDA30226.attr preserve=no  private: double {UA} upperBound
      double upper;
      //## end UniformGenerator::upper%3EE8EDA30226.attr

    // Additional Private Declarations
      //## begin UniformGenerator%3EE0A9C8001E.private preserve=yes
      //## end UniformGenerator%3EE0A9C8001E.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin UniformGenerator%3EE0A9C8001E.implementation preserve=yes
      //## end UniformGenerator%3EE0A9C8001E.implementation

};

//## begin UniformGenerator%3EE0A9C8001E.postscript preserve=yes
//## end UniformGenerator%3EE0A9C8001E.postscript

// Class UniformGenerator 

inline UniformGenerator::UniformGenerator (double lowerBound, double upperBound)
  //## begin UniformGenerator::UniformGenerator%3EE8EDCB0140.hasinit preserve=no
      : lower(lowerBound),
        upper(upperBound)
  //## end UniformGenerator::UniformGenerator%3EE8EDCB0140.hasinit
  //## begin UniformGenerator::UniformGenerator%3EE8EDCB0140.initialization preserve=yes
  //## end UniformGenerator::UniformGenerator%3EE8EDCB0140.initialization
{
  //## begin UniformGenerator::UniformGenerator%3EE8EDCB0140.body preserve=yes
  //## end UniformGenerator::UniformGenerator%3EE8EDCB0140.body
}



//## Other Operations (inline)
inline String UniformGenerator::getDistributionName ()
{
  //## begin UniformGenerator::getDistributionName%3EEB1A290104.body preserve=yes
	return "Uniform";
  //## end UniformGenerator::getDistributionName%3EEB1A290104.body
}

inline double UniformGenerator::getMeanValue ()
{
  //## begin UniformGenerator::getMeanValue%3EE8EEDE0262.body preserve=yes
	return (lower+upper)/2.0;
  //## end UniformGenerator::getMeanValue%3EE8EEDE0262.body
}

//## begin module%3EEB3EBF02BC.epilog preserve=yes
//## end module%3EEB3EBF02BC.epilog


#endif
