#include "Modeling.h"

void buildModel () {

	// North-South:
	FlowSink* e1 = new FlowSink();
	e1->setName("South str.");

	QueuedServer* e2 = new QueuedServer(3);
	e2->setName("South sq.");
	e2->target = e1;

	QueuedServer* e3 = new QueuedServer(2);
	e3->setName("North str.");
	e3->target = e2;

	Pipe* e4 = new Pipe(4);
	e4->setName("North str.");
	e4->target = e3;

	FlowSource* e5 = new FlowSource(5);
	e5->setName("North");
	e5->target = e4;

	FlowSink* e6 = new FlowSink();
	e6->setName("North str.");



	// West-East:
	FlowSink* e7 = new FlowSink();
	e7->setName("East str.");

	Switch1to3* e8 = new Switch1to3(0.2,0.4);
	e8->setName("West str.");
	e8->target = e7;
	e8->leftTarget = e6;
	e8->rightTarget = e2;

	QueuedServer* e9 = new QueuedServer(3);
	e9->setName("West sq.");
	e9->target = e8;

	Pipe* e10 = new Pipe(4);
	e10->setName("West str.");
	e10->target = e9;

	FlowSource* e11 = new FlowSource(5);
	e11->setName("West");
	e11->target = e10;

	// Semaphores:
	CrossSemaphore* e12 = new CrossSemaphore(3,5); // Try later with (4,5)!
	e12->setName("South sq.");
	e12->horSource[0] = e2;

	CrossSemaphore* e13 = new CrossSemaphore(3,5);
	e13->setName("North sq.");
	e13->horSource[0] = e3;
	e13->verSource[0] = e9;
}