//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB408F0302.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB408F0302.cm

//## begin module%3EEB408F0302.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB408F0302.cp

//## Module: Event%3EEB408F0302; Package specification
//## Subsystem: Simulation Engine%3EEB3A44005A
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Simulation Engine\Event.h

#ifndef Event_h
#define Event_h 1

//## begin module%3EEB408F0302.additionalIncludes preserve=no
//## end module%3EEB408F0302.additionalIncludes

//## begin module%3EEB408F0302.includes preserve=yes
#include "Interfaces.h"
//## end module%3EEB408F0302.includes

//## begin module%3EEB408F0302.declarations preserve=no
//## end module%3EEB408F0302.declarations

//## begin module%3EEB408F0302.additionalDeclarations preserve=yes
//## end module%3EEB408F0302.additionalDeclarations


//## begin Event%3EE096C503CA.preface preserve=yes
//## end Event%3EE096C503CA.preface

//## Class: Event%3EE096C503CA
//	A discrete occurrence in time, dedicated to an ITimed
//	Element.
//## Category: Traffic Modeling and Simulation::Simulation Engine%3EE07FDE00E6
//## Subsystem: Simulation Engine%3EEB3A44005A
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class Event 
{
  //## begin Event%3EE096C503CA.initialDeclarations preserve=yes
  //## end Event%3EE096C503CA.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: create%3EE097EE01FE
      //	Static. Raises an Event and sends it to the simulation
      //	engine. Accepts the target, the time (relative to the
      //	current moment), and the ID of the Event.
      static void create (ITimedElement* targetElement, Time tm, ID id = 0);

      //## Operation: getID%3EE0985D026C
      //	Returns the ID of the Event.
      virtual ID getID ();

      //## Operation: getTarget%3EE0986E0172
      //	Returns the target of the Event.
      virtual ITimedElement* getTarget ();

      //## Operation: getTime%3EE0987D0398
      //	Returns the scheduled time of the Event (relative to the
      //	previous Event in the Scheduler's list).
      virtual Time getTime ();

      //## Operation: setTime%3EE0D3C602C6
      //	Sets the scheduled time of the Event (relative to the
      //	previous Event in the Scheduler's list).
      virtual void setTime (Time newTime);

      //## Operation: getNext%3EE0D3E701C2
      //	Returns the next scheduled Event in the Scheduler's list.
      virtual Event* getNext ();

      //## Operation: setNext%3EE0D3E701F4
      //	Sets the next scheduled Event in the Scheduler's list.
      virtual void setNext (Event* nxt);

    // Additional Public Declarations
      //## begin Event%3EE096C503CA.public preserve=yes
      //## end Event%3EE096C503CA.public

  protected:
    //## Constructors (specified)
      //## Operation: Event%3EE0995402DA
      //	Constructor. Accepts the target, the time (relative to
      //	the current moment), and the ID of the Event.
      Event (ITimedElement* targetElement, Time tm, ID i = 0);

    // Additional Protected Declarations
      //## begin Event%3EE096C503CA.protected preserve=yes
      //## end Event%3EE096C503CA.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: id%3EE096F902BC
      //	Auxiliary identification of the occurrence.
      //## begin Event::id%3EE096F902BC.attr preserve=no  private: ID {UA} i
      ID id;
      //## end Event::id%3EE096F902BC.attr

      //## Attribute: time%3EE0972900A0
      //	The time at which the Event is scheduled to occur.
      //	Relative to the previous Event in the Scheduler's list,
      //	or to the current moment, if it is the first in the list.
      //## begin Event::time%3EE0972900A0.attr preserve=no  private: Time {UA} tm
      Time time;
      //## end Event::time%3EE0972900A0.attr

    // Data Members for Associations

      //## Association: Traffic Modeling and Simulation::Simulation Engine::<unnamed>%3EE0D36200FA
      //## Role: Event::next%3EE0D3640078
      //## begin Event::next%3EE0D3640078.role preserve=no  private: Event {0..1 -> 0..1RFHAN}
      Event *next;
      //## end Event::next%3EE0D3640078.role

      //## Association: Traffic Modeling and Simulation::Simulation Engine::<unnamed>%3EE0975F02BC
      //## Role: Event::target%3EE097600168
      //## begin Event::target%3EE097600168.role preserve=no  private: ITimedElement {n -> 1RFHAN}
      ITimedElement *target;
      //## end Event::target%3EE097600168.role

    // Additional Private Declarations
      //## begin Event%3EE096C503CA.private preserve=yes
      //## end Event%3EE096C503CA.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin Event%3EE096C503CA.implementation preserve=yes
      //## end Event%3EE096C503CA.implementation

};

//## begin Event%3EE096C503CA.postscript preserve=yes
//## end Event%3EE096C503CA.postscript

// Class Event 


//## Other Operations (inline)
inline void Event::create (ITimedElement* targetElement, Time tm, ID id)
{
  //## begin Event::create%3EE097EE01FE.body preserve=yes
	new Event(targetElement,tm,id);
  //## end Event::create%3EE097EE01FE.body
}

inline ID Event::getID ()
{
  //## begin Event::getID%3EE0985D026C.body preserve=yes
	return id;
  //## end Event::getID%3EE0985D026C.body
}

inline ITimedElement* Event::getTarget ()
{
  //## begin Event::getTarget%3EE0986E0172.body preserve=yes
	return target;
  //## end Event::getTarget%3EE0986E0172.body
}

inline Time Event::getTime ()
{
  //## begin Event::getTime%3EE0987D0398.body preserve=yes
	return time;
  //## end Event::getTime%3EE0987D0398.body
}

inline void Event::setTime (Time newTime)
{
  //## begin Event::setTime%3EE0D3C602C6.body preserve=yes
	time = newTime;
  //## end Event::setTime%3EE0D3C602C6.body
}

inline Event* Event::getNext ()
{
  //## begin Event::getNext%3EE0D3E701C2.body preserve=yes
	return next;
  //## end Event::getNext%3EE0D3E701C2.body
}

inline void Event::setNext (Event* nxt)
{
  //## begin Event::setNext%3EE0D3E701F4.body preserve=yes
	next = nxt;
  //## end Event::setNext%3EE0D3E701F4.body
}

//## begin module%3EEB408F0302.epilog preserve=yes
//## end module%3EEB408F0302.epilog


#endif
