//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB40A100E6.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB40A100E6.cm

//## begin module%3EEB40A100E6.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB40A100E6.cp

//## Module: SimEng%3EEB40A100E6; Package body
//## Subsystem: Simulation Engine%3EEB3A44005A
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Simulation Engine\SimEng.cpp

//## begin module%3EEB40A100E6.additionalIncludes preserve=no
//## end module%3EEB40A100E6.additionalIncludes

//## begin module%3EEB40A100E6.includes preserve=yes
//## end module%3EEB40A100E6.includes

// Event
#include "Event.h"
// Sched
#include "Sched.h"

class ITimedElement;

//## begin module%3EEB40A100E6.declarations preserve=no
//## end module%3EEB40A100E6.declarations

//## begin module%3EEB40A100E6.additionalDeclarations preserve=yes
//## end module%3EEB40A100E6.additionalDeclarations


// Class Event 







Event::Event (ITimedElement* targetElement, Time tm, ID i)
  //## begin Event::Event%3EE0995402DA.hasinit preserve=no
      : id(i),
        time(tm)
  //## end Event::Event%3EE0995402DA.hasinit
  //## begin Event::Event%3EE0995402DA.initialization preserve=yes
  , next(0), target(targetElement)
  //## end Event::Event%3EE0995402DA.initialization
{
  //## begin Event::Event%3EE0995402DA.body preserve=yes
	Scheduler::Instance()->put(this);
  //## end Event::Event%3EE0995402DA.body
}


// Additional Declarations
  //## begin Event%3EE096C503CA.declarations preserve=yes
  //## end Event%3EE096C503CA.declarations

// Class Scheduler 




//## Other Operations (implementation)
Scheduler* Scheduler::Instance ()
{
  //## begin Scheduler::Instance%3EE0D2D00064.body preserve=yes
	static Scheduler instance;
	return &instance;
  //## end Scheduler::Instance%3EE0D2D00064.body
}

void Scheduler::put (Event* ev)
{
  //## begin Scheduler::put%3EE0D4350226.body preserve=yes
	if (ev==0) return;
	Time time = ev->getTime();
	Event* nxt = first;
	Event* prv = 0;
	
	while (nxt!=0 && time >= nxt->getTime()) {
		time -= nxt->getTime();
		prv = nxt;
		nxt = nxt->getNext();
	}
	
	if (nxt) nxt->setTime(nxt->getTime() - time);
	ev->setTime(time);
	ev->setNext(nxt);
	if (prv!=0) prv->setNext(ev); else first = ev;    
  //## end Scheduler::put%3EE0D4350226.body
}

bool Scheduler::processOneEvent ()
{
  //## begin Scheduler::processOneEvent%3EE0D53F0118.body preserve=yes
	Event* ev = first;
	if (ev==0) return false;
	first = first->getNext();
	curTime += ev->getTime();
	ITimedElement* el = ev->getTarget();
	if (el) el->notify(ev->getID());
	delete ev;
	return (first && first->getTime()==0);
  //## end Scheduler::processOneEvent%3EE0D53F0118.body
}

bool Scheduler::processNow ()
{
  //## begin Scheduler::processNow%3EE0D4E6008C.body preserve=yes
	while (processOneEvent());
	return (first!=0);
  //## end Scheduler::processNow%3EE0D4E6008C.body
}

// Additional Declarations
  //## begin Scheduler%3EE0D27C0000.declarations preserve=yes
  //## end Scheduler%3EE0D27C0000.declarations

//## begin module%3EEB40A100E6.epilog preserve=yes
//## end module%3EEB40A100E6.epilog
