//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB41F80352.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB41F80352.cm

//## begin module%3EEB41F80352.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB41F80352.cp

//## Module: VModelChecker%3EEB41F80352; Package body
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\VModelChecker.cpp

//## begin module%3EEB41F80352.additionalIncludes preserve=no
//## end module%3EEB41F80352.additionalIncludes

//## begin module%3EEB41F80352.includes preserve=yes
#include "UniRndGen.h"
#include "ExpRndGen.h"
#include "Modeling.h"
//## end module%3EEB41F80352.includes

// VModelChecker
#include "VModelChecker.h"
//## begin module%3EEB41F80352.declarations preserve=no
//## end module%3EEB41F80352.declarations

//## begin module%3EEB41F80352.additionalDeclarations preserve=yes
//## end module%3EEB41F80352.additionalDeclarations


// Class VisModelChecker 


//## Other Operations (implementation)
void VisModelChecker::outputViolation (ModelElement* me, char* tpStr, char* str, bool error)
{
  //## begin VisModelChecker::outputViolation%3EEE20E30118.body preserve=yes
	if (me==0) return;
	writeNameType(me,tpStr);
	output("\n\t");
	if (error) output("Error: "); else output("Warning: ");
	output(str);
	output();
  //## end VisModelChecker::outputViolation%3EEE20E30118.body
}

void VisModelChecker::visitUniformGenerator (UniformGenerator* e)
{
  //## begin VisModelChecker::visitUniformGenerator%3EEB17CB00D2.body preserve=yes
	if (e==0) return;
	if (e->getMeanValue()<0) output("\tMean value less than 0.\n");
  //## end VisModelChecker::visitUniformGenerator%3EEB17CB00D2.body
}

void VisModelChecker::visitExpGenerator (ExpGenerator* e)
{
  //## begin VisModelChecker::visitExpGenerator%3EEB17CB0104.body preserve=yes
	if (e==0) return;
	if (e->getMeanValue()<0) output("\tMean value less than 0.\n");
  //## end VisModelChecker::visitExpGenerator%3EEB17CB0104.body
}

void VisModelChecker::visitFlowSource (FlowSource* e)
{
  //## begin VisModelChecker::visitFlowSource%3EEB17CB0106.body preserve=yes
	if (e==0) return;
	if (e->target==0) outputViolation(e,"Flow Source","No target for the flow source.",true);
	output();
  //## end VisModelChecker::visitFlowSource%3EEB17CB0106.body
}

void VisModelChecker::visitFlowSink (FlowSink* e)
{
  //## begin VisModelChecker::visitFlowSink%3EEB17CB0140.body preserve=yes
	if (e==0) return;
	if (e->target!=0) outputViolation(e,"Flow Sink","Target of the flow sink has no effect.",true);
	output();
  //## end VisModelChecker::visitFlowSink%3EEB17CB0140.body
}

void VisModelChecker::visitPipe (Pipe* e)
{
  //## begin VisModelChecker::visitPipe%3EEB17CB0142.body preserve=yes
	if (e==0) return;
	if (e->target==0) outputViolation(e,"Pipe","No target for the pipe.",true);
	RandomGenerator* rndGen = e->getRndGen();
	if (rndGen==0) outputViolation(e,"Pipe","No random generator.",true);
	output();
  //## end VisModelChecker::visitPipe%3EEB17CB0142.body
}

void VisModelChecker::visitQueuedServer (QueuedServer* e)
{
  //## begin VisModelChecker::visitQueuedServer%3EEB17CB0172.body preserve=yes
	if (e==0) return;
	if (e->target==0) outputViolation(e,"Queued Server","No target for the server.",true);
	RandomGenerator* rndGen = e->getRndGen();
	if (rndGen==0) outputViolation(e,"Pipe","No random generator.",true);
	output();
  //## end VisModelChecker::visitQueuedServer%3EEB17CB0172.body
}

void VisModelChecker::visitSwitch1to3 (Switch1to3* e)
{
  //## begin VisModelChecker::visitSwitch1to3%3EEB17CB0174.body preserve=yes
	if (e==0) return;
	if (e->target==0) outputViolation(e,"Switch","No straight target for the switch.",true);
	if (e->leftTarget==0) outputViolation(e,"Switch","No left target for the switch.",true);
	if (e->rightTarget==0) outputViolation(e,"Switch","No right target for the switch.",true);
	output();
  //## end VisModelChecker::visitSwitch1to3%3EEB17CB0174.body
}

void VisModelChecker::visitCrossSemaphore (CrossSemaphore* e)
{
  //## begin VisModelChecker::visitCrossSemaphore%3EEB17CB01AE.body preserve=yes
	if (e==0) return;
	if (e->horSource[0]==0 && e->horSource[1]==0) outputViolation(e,"Cross Semaphore","No horizontal source for the semaphore.",false);
	if (e->verSource[0]==0 && e->verSource[1]==0) outputViolation(e,"Cross Semaphore","No vertical source for the semaphore.",false);
	output();
  //## end VisModelChecker::visitCrossSemaphore%3EEB17CB01AE.body
}

// Additional Declarations
  //## begin VisModelChecker%3EEB17660244.declarations preserve=yes
  //## end VisModelChecker%3EEB17660244.declarations

//## begin module%3EEB41F80352.epilog preserve=yes
//## end module%3EEB41F80352.epilog
