//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB41E90050.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB41E90050.cm

//## begin module%3EEB41E90050.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB41E90050.cp

//## Module: VModelChecker%3EEB41E90050; Package specification
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\VModelChecker.h

#ifndef VModelChecker_h
#define VModelChecker_h 1

//## begin module%3EEB41E90050.additionalIncludes preserve=no
//## end module%3EEB41E90050.additionalIncludes

//## begin module%3EEB41E90050.includes preserve=yes
#include "VTxtOutputGen.h"
//## end module%3EEB41E90050.includes

//## begin module%3EEB41E90050.declarations preserve=no
//## end module%3EEB41E90050.declarations

//## begin module%3EEB41E90050.additionalDeclarations preserve=yes
//## end module%3EEB41E90050.additionalDeclarations


//## begin VisModelChecker%3EEB17660244.preface preserve=yes
//## end VisModelChecker%3EEB17660244.preface

//## Class: VisModelChecker%3EEB17660244
//	A Visitor that verifies the wellformednes of the model
//	and reports violations to the output stream.
//## Category: Traffic Modeling and Simulation::Visitors%3EEB0CA50186
//## Subsystem: Visitors%3EEB3A5302B2
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class VisModelChecker : public VisTxtOutputGenerator  //## Inherits: <unnamed>%3EEB17FF0294
{
  //## begin VisModelChecker%3EEB17660244.initialDeclarations preserve=yes
  //## end VisModelChecker%3EEB17660244.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: VisModelChecker%3EEB17990230
      //	Constructor. Accepts an output stream to generate the
      //	report.
      VisModelChecker (ostream* output);


    //## Other Operations (specified)
      //## Operation: visitUniformGenerator%3EEB17CB00D2
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitUniformGenerator (UniformGenerator* e);

      //## Operation: visitExpGenerator%3EEB17CB0104
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitExpGenerator (ExpGenerator* e);

      //## Operation: visitFlowSource%3EEB17CB0106
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitFlowSource (FlowSource* e);

      //## Operation: visitFlowSink%3EEB17CB0140
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitFlowSink (FlowSink* e);

      //## Operation: visitPipe%3EEB17CB0142
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitPipe (Pipe* e);

      //## Operation: visitQueuedServer%3EEB17CB0172
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitQueuedServer (QueuedServer* e);

      //## Operation: visitSwitch1to3%3EEB17CB0174
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitSwitch1to3 (Switch1to3* e);

      //## Operation: visitCrossSemaphore%3EEB17CB01AE
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitCrossSemaphore (CrossSemaphore* e);

    // Additional Public Declarations
      //## begin VisModelChecker%3EEB17660244.public preserve=yes
      //## end VisModelChecker%3EEB17660244.public

  protected:

    //## Other Operations (specified)
      //## Operation: outputViolation%3EEE20E30118
      //	Helper. Displays an error or a warning for the given
      //	model element.
      virtual void outputViolation (ModelElement* me, char* tpStr, char* str, bool error = true);

    // Additional Protected Declarations
      //## begin VisModelChecker%3EEB17660244.protected preserve=yes
      //## end VisModelChecker%3EEB17660244.protected

  private:
    // Additional Private Declarations
      //## begin VisModelChecker%3EEB17660244.private preserve=yes
      //## end VisModelChecker%3EEB17660244.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin VisModelChecker%3EEB17660244.implementation preserve=yes
      //## end VisModelChecker%3EEB17660244.implementation

};

//## begin VisModelChecker%3EEB17660244.postscript preserve=yes
//## end VisModelChecker%3EEB17660244.postscript

// Class VisModelChecker 

inline VisModelChecker::VisModelChecker (ostream* output)
  //## begin VisModelChecker::VisModelChecker%3EEB17990230.hasinit preserve=no
  //## end VisModelChecker::VisModelChecker%3EEB17990230.hasinit
  //## begin VisModelChecker::VisModelChecker%3EEB17990230.initialization preserve=yes
  : VisTxtOutputGenerator(output)
  //## end VisModelChecker::VisModelChecker%3EEB17990230.initialization
{
  //## begin VisModelChecker::VisModelChecker%3EEB17990230.body preserve=yes
  //## end VisModelChecker::VisModelChecker%3EEB17990230.body
}


//## begin module%3EEB41E90050.epilog preserve=yes
//## end module%3EEB41E90050.epilog


#endif
