//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB425100DC.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB425100DC.cm

//## begin module%3EEB425100DC.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB425100DC.cp

//## Module: VSimReporter%3EEB425100DC; Package body
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\VSimReporter.cpp

//## begin module%3EEB425100DC.additionalIncludes preserve=no
//## end module%3EEB425100DC.additionalIncludes

//## begin module%3EEB425100DC.includes preserve=yes
#include "UniRndGen.h"
#include "ExpRndGen.h"
#include "Modeling.h"
#include <iostream.h>
//## end module%3EEB425100DC.includes

// VSimReporter
#include "VSimReporter.h"
//## begin module%3EEB425100DC.declarations preserve=no
//## end module%3EEB425100DC.declarations

//## begin module%3EEB425100DC.additionalDeclarations preserve=yes
//## end module%3EEB425100DC.additionalDeclarations


// Class VisSimulationReporter 


//## Other Operations (implementation)
void VisSimulationReporter::visitFlowElement (FlowElement* fe, char* typeStr)
{
  //## begin VisSimulationReporter::visitFlowElement%3EEF5B3A0050.body preserve=yes
	if (fe==0) return;
	output("\n\n");
	writeNameType(fe,typeStr);
	output("\nTotal occurrences: ");
	if (out) (*out)<<fe->getNumOfOccurrences()<<"\n";
  //## end VisSimulationReporter::visitFlowElement%3EEF5B3A0050.body
}

void VisSimulationReporter::visitUniformGenerator (UniformGenerator* e)
{
  //## begin VisSimulationReporter::visitUniformGenerator%3EEB1CCF039B.body preserve=yes
  //## end VisSimulationReporter::visitUniformGenerator%3EEB1CCF039B.body
}

void VisSimulationReporter::visitExpGenerator (ExpGenerator* e)
{
  //## begin VisSimulationReporter::visitExpGenerator%3EEB1CCF039D.body preserve=yes
  //## end VisSimulationReporter::visitExpGenerator%3EEB1CCF039D.body
}

void VisSimulationReporter::visitFlowSource (FlowSource* e)
{
  //## begin VisSimulationReporter::visitFlowSource%3EEB1CCF039F.body preserve=yes
	visitFlowElement(e,"Flow Source");
  //## end VisSimulationReporter::visitFlowSource%3EEB1CCF039F.body
}

void VisSimulationReporter::visitFlowSink (FlowSink* e)
{
  //## begin VisSimulationReporter::visitFlowSink%3EEB1CCF03A1.body preserve=yes
	visitFlowElement(e,"Flow Sink");
  //## end VisSimulationReporter::visitFlowSink%3EEB1CCF03A1.body
}

void VisSimulationReporter::visitPipe (Pipe* e)
{
  //## begin VisSimulationReporter::visitPipe%3EEB1CCF03A3.body preserve=yes
	visitFlowElement(e,"Pipe");
  //## end VisSimulationReporter::visitPipe%3EEB1CCF03A3.body
}

void VisSimulationReporter::visitQueuedServer (QueuedServer* e)
{
  //## begin VisSimulationReporter::visitQueuedServer%3EEB1CCF03A5.body preserve=yes
	if (e==0) return;
	visitFlowElement(e,"Queued Server");
	if (out) {
		(*out)<<"Currently serving: "<<e->isCurrentlyServing()<<"\n";
		(*out)<<"Current queue size: "<<e->getQueueSize()<<"\n";
		(*out)<<"Maximum queue size: "<<e->getMaxQueueSize()<<"\n";
	}
  //## end VisSimulationReporter::visitQueuedServer%3EEB1CCF03A5.body
}

void VisSimulationReporter::visitSwitch1to3 (Switch1to3* e)
{
  //## begin VisSimulationReporter::visitSwitch1to3%3EEB1CCF03A7.body preserve=yes
	visitFlowElement(e,"Switch 1 to 3");
  //## end VisSimulationReporter::visitSwitch1to3%3EEB1CCF03A7.body
}

void VisSimulationReporter::visitCrossSemaphore (CrossSemaphore* e)
{
  //## begin VisSimulationReporter::visitCrossSemaphore%3EEB1CCF03CA.body preserve=yes
  //## end VisSimulationReporter::visitCrossSemaphore%3EEB1CCF03CA.body
}

// Additional Declarations
  //## begin VisSimulationReporter%3EEB1CCF0398.declarations preserve=yes
  //## end VisSimulationReporter%3EEB1CCF0398.declarations

//## begin module%3EEB425100DC.epilog preserve=yes
//## end module%3EEB425100DC.epilog
