//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB423A024E.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB423A024E.cm

//## begin module%3EEB423A024E.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB423A024E.cp

//## Module: VSimReporter%3EEB423A024E; Package specification
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\VSimReporter.h

#ifndef VSimReporter_h
#define VSimReporter_h 1

//## begin module%3EEB423A024E.additionalIncludes preserve=no
//## end module%3EEB423A024E.additionalIncludes

//## begin module%3EEB423A024E.includes preserve=yes
#include "VTxtOutputGen.h"
//## end module%3EEB423A024E.includes

//## begin module%3EEB423A024E.declarations preserve=no
//## end module%3EEB423A024E.declarations

//## begin module%3EEB423A024E.additionalDeclarations preserve=yes
//## end module%3EEB423A024E.additionalDeclarations


//## begin VisSimulationReporter%3EEB1CCF0398.preface preserve=yes
//## end VisSimulationReporter%3EEB1CCF0398.preface

//## Class: VisSimulationReporter%3EEB1CCF0398
//	A Visitor that traverses the model and generates the
//	simulation report at the current moment.
//## Category: Traffic Modeling and Simulation::Visitors%3EEB0CA50186
//## Subsystem: Visitors%3EEB3A5302B2
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class VisSimulationReporter : public VisTxtOutputGenerator  //## Inherits: <unnamed>%3EEB1CCF03CC
{
  //## begin VisSimulationReporter%3EEB1CCF0398.initialDeclarations preserve=yes
  //## end VisSimulationReporter%3EEB1CCF0398.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: VisSimulationReporter%3EEB1CCF0399
      //	Constructor. Accepts an output stream to generate the
      //	report.
      VisSimulationReporter (ostream* output);


    //## Other Operations (specified)
      //## Operation: visitUniformGenerator%3EEB1CCF039B
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitUniformGenerator (UniformGenerator* e);

      //## Operation: visitExpGenerator%3EEB1CCF039D
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitExpGenerator (ExpGenerator* e);

      //## Operation: visitFlowSource%3EEB1CCF039F
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitFlowSource (FlowSource* e);

      //## Operation: visitFlowSink%3EEB1CCF03A1
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitFlowSink (FlowSink* e);

      //## Operation: visitPipe%3EEB1CCF03A3
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitPipe (Pipe* e);

      //## Operation: visitQueuedServer%3EEB1CCF03A5
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitQueuedServer (QueuedServer* e);

      //## Operation: visitSwitch1to3%3EEB1CCF03A7
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitSwitch1to3 (Switch1to3* e);

      //## Operation: visitCrossSemaphore%3EEB1CCF03CA
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitCrossSemaphore (CrossSemaphore* e);

    // Additional Public Declarations
      //## begin VisSimulationReporter%3EEB1CCF0398.public preserve=yes
      //## end VisSimulationReporter%3EEB1CCF0398.public

  protected:

    //## Other Operations (specified)
      //## Operation: visitFlowElement%3EEF5B3A0050
      //	Helper. Visits a Flow Element. Writes its ID, name,
      //	description, the target's data, and the number of
      //	transported occurrences.
      virtual void visitFlowElement (FlowElement* fe, char* typeStr);

    // Additional Protected Declarations
      //## begin VisSimulationReporter%3EEB1CCF0398.protected preserve=yes
      //## end VisSimulationReporter%3EEB1CCF0398.protected

  private:
    // Additional Private Declarations
      //## begin VisSimulationReporter%3EEB1CCF0398.private preserve=yes
      //## end VisSimulationReporter%3EEB1CCF0398.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin VisSimulationReporter%3EEB1CCF0398.implementation preserve=yes
      //## end VisSimulationReporter%3EEB1CCF0398.implementation

};

//## begin VisSimulationReporter%3EEB1CCF0398.postscript preserve=yes
//## end VisSimulationReporter%3EEB1CCF0398.postscript

// Class VisSimulationReporter 

inline VisSimulationReporter::VisSimulationReporter (ostream* output)
  //## begin VisSimulationReporter::VisSimulationReporter%3EEB1CCF0399.hasinit preserve=no
  //## end VisSimulationReporter::VisSimulationReporter%3EEB1CCF0399.hasinit
  //## begin VisSimulationReporter::VisSimulationReporter%3EEB1CCF0399.initialization preserve=yes
  : VisTxtOutputGenerator(output)
  //## end VisSimulationReporter::VisSimulationReporter%3EEB1CCF0399.initialization
{
  //## begin VisSimulationReporter::VisSimulationReporter%3EEB1CCF0399.body preserve=yes
  //## end VisSimulationReporter::VisSimulationReporter%3EEB1CCF0399.body
}


//## begin module%3EEB423A024E.epilog preserve=yes
//## end module%3EEB423A024E.epilog


#endif
